<?php
/**
 * @package MadIrish-Webmail
 * @author Justin C. Klein Keane
 * @version 2.0
 * 
 * Calendar interface.
 * 
 */
$title = "Calendar";
$javascripts = array('valiDate.js');

require_once ($GLOBALS['basedir']."lib/email.php");
require_once ($GLOBALS['basedir']."lib/calendar.php");
require_once ($GLOBALS['basedir']."lib/sql.php");
require_once ($GLOBALS['basedir']."lib/html.php");
  
$security_check = new Email();
$calendar = new Calendar();
$sql = new Sql();
$html = new Html();

include ($GLOBALS['basedir']."inc/header.php");
include ($GLOBALS['basedir']."inc/navbar.php");

if (isset($_REQUEST['delete']))
	doDelete($_REQUEST['id']); //ref local func below
if (isset($_POST['title'])) 
	doAddEdit(); //ref local func below
	
$calendar->highlight_days = getHighlights(); //ref local func below

echo $html->table_start('id="container"');

echo $html->tr(
		$html->td(
			$calendar->showCalendarNav() .
			$calendar->showMonth() . 
			showAddButton() //ref local func below
			,'valign="top"'
		) .
		$html->td(
			pageDisplay() //ref local func below
		)
);
echo $html->table_end();

include ($GLOBALS['basedir']."inc/footer.php");




/**********************
	local functions
**********************/
function getHighlights() {
	global $calendar, $security_check, $sql;
	//get the days where there are events:
	$theQuery = "SELECT unix_timestamp(from_days(a.annual_startday)) as theDay, 
						unix_timestamp(from_days(a.annual_endday)) as endDay,
						a.annual_interval as theInterval
				 FROM cal_annual a, 
				 	  cal_event e
				 WHERE 
				 	(
				 		a.annual_startday > to_days('" . $calendar->year . '-' . $calendar->month . "-1') 
						OR a.annual_nostart = 1
					)
				 	AND 
				 	(
				 		a.annual_startday < to_days('" . $calendar->year . '-' . $calendar->month . '-' . $calendar->days_in_the_month . "')
						OR annual_endday IS NULL
					)
					AND (e.event_owner = '" . $security_check->username . "' OR e.event_owner = 'all')";
	
	$retval = $sql->selectSQL($theQuery);
	if (isset($retval)) {
		foreach ($retval as $ret) {
			extract($ret);
			$theDay = date('d', $theDay);
			$endDay = date('d', $endDay);
			while (($theDay < $calendar->days_in_the_month) && ($theDay <= $endDay)) {
				$daysList[] =  $theDay;
				$theDay = $theDay + $theInterval;
			}
		}
	}
	
	$theQuery = "SELECT d.dayofmonth_day as theDay 
					FROM cal_dayofmonth d, cal_event e
					WHERE (e.event_owner = '" . $security_check->username . "' OR e.event_owner = 'all')
					AND e.event_id = d.event_id";
	
	$retval = $sql->selectSQL($theQuery);
	if (isset($retval)) {
		foreach ($retval as $ret) 
			$daysList[] = $ret['theDay'];
	}
	
	
	$theQuery = "SELECT SUBSTRING(s.specdate_date,(locate('-',s.specdate_date)+1)) AS theDay
				 FROM cal_specdate s, cal_event e
				 WHERE LEFT(s.specdate_date,locate('-',s.specdate_date)-1) = " . $calendar->month . 
				 " AND (e.event_owner = '" . $security_check->username . "' OR e.event_owner = 'all')
				   AND e.event_id = s.event_id";
	
	$retval = $sql->selectSQL($theQuery);
	if (isset($retval)) {
		foreach ($retval as $ret) 
			$daysList[] = $ret['theDay'];
	}
	
	return $daysList;
}

function pageDisplay() {
	global $sql, $security_check, $html;
	

	if (isset($_REQUEST['edit'])) {
		$id = $_REQUEST['id'];
		$retval = "<form name='addForm' method='post' action='?update=yes&id=" . $_GET['id'] . "'>";
		$result = $sql->selectSQL("SELECT e.event_id, e.event_owner, e.event_title, e.event_desc 
							 FROM cal_event e 
							 WHERE e.event_id = '$id' 
							 AND (e.event_owner = '$username' OR e.event_owner = 'all')");
		if (isset($result)) {
			foreach ($result as $record) {
				extract($record);
							$theTitle = $event_title;
							$theDesc = $event_desc;
							$theOwner = $event_owner;
							if ($theOwner == $security_check->username) 
								$priv = 'checked';
							else 	
								$open = 'checked';
			}
		}
		$retval .= "<span id='editTitle'>Event:</span><br/><br/>";
		$retval .= $html->table_start('class="editTable"');
		$retval .= $html->tr(
								$html->td('Event Title') . 
								$html->td( $html->textinput('title', 'value="' . $theTitle . '"'))
					);
		$retval .= $html->tr(
								$html->td('Event Description') . 
								$html->td( $html->textarea('desc', $theDesc, '',10,50))
					);
		$retval .= $html->tr(
								$html->td('Show this event to:') . 
								$html->td( $html->radio('owner','justme',$priv) . 'Just me' .
											$html->br . 
											$html->radio('owner','all',$open) . 'Everyone') 
					);
		$retval .= $html->table_end();
		$retval .= "<input type='submit' value='Add'/>";
		$retval .= "</form>";
		
		return $retval;
	}
	elseif (isset($_REQUEST['add'])) {
		return showAddForm();
	}
	elseif (isset($_REQUEST['year'])) {
		$theDate = $_REQUEST['year'] . '-' . $_REQUEST['month'] . '-' . $_REQUEST['day'];
		//view
		$theQuery  = "SELECT e.event_id, e.event_title, e.event_desc 
						FROM cal_event e 
						LEFT OUTER JOIN cal_annual a ON 
							a.event_id = e.event_id 
						LEFT OUTER JOIN cal_specdate s ON 
							s.event_id = e.event_id 
						LEFT OUTER JOIN cal_dayofmonth d ON 
							d.event_id = e.event_id 
						WHERE 
						(
							(a.annual_startday <= to_days('" . $theDate . "') 
							AND a.annual_endday >= to_days('" . $theDate . "'))
							OR
							(
								(to_days('" . $theDate . "') - a.annual_startday) % a.annual_interval = a.annual_startday
							)
		
						) 
						OR 
						(date_format('" . $theDate . "', '%c-%e') = s.specdate_date) 
						OR 
						(d.dayofmonth_day = '" . $_REQUEST['day'] . "' 
							AND (e.event_owner = '" . $security_check->username . "' 
							OR e.event_owner = 'all')
						)";
		
		$retvals = $sql->selectSQL($theQuery);
		if (isset($retvals)) {
			foreach ($retvals as $ret) 
				$retval .= '<span id="event_title">'. $ret['event_title'] . '</span><br/>';
				$retval .= '<span id="event_desc">' . $ret['event_desc'] . '</span><br/>';
				$retval .= '<span id="edit"><a href="?day=' .$_REQUEST['day']. '&month=' .$_REQUEST['month']. '&year=' .$_REQUEST['year']. '&id=' .$ret['event_id']. '&edit=yes">edit</a></span>';
				$retval .= '<br/>';
				$retval .= '<span id="delete"><a href="?delete=yes&id=' .$ret['event_id']. '" onclick=\'return ruSure("' . $ret['event_id'] . '")\'>delete</a></span>';
				$retval .= '<br/>';
		}
			
		return $retval;
		
	}
}

function showAddButton() {
	return "<span id='addButton'><a href='?add=yes'>Add Event</a></span>";
}

function doDelete($id) {
	global $sql;
	
	$sql->iudSQL("delete from cal_event where event_id = '$id'");
	$sql->iudSQL("delete from cal_annual where event_id = '$id'");
	$sql->iudSQL("delete from cal_specdate where event_id = '$id'");
}

function doAddEdit() {
	global $sql, $security_check;
	if ($_POST['event_id']) {
		//edit
		if ($_POST['owner'] == 'justme') $_POST['owner'] = $security_check->username;
		$sql->iudSQL("UPDATE cal_event 
						SET event_title = '" . $_POST['title'] . "', 
							event_desc = '" . $_POST['desc'] . "', 
							event_owner = '" . $_POST['owner'] . "' 
						WHERE event_id = " . $_GET['id']);
	}
	else {
		//add
		if ($_POST['owner'] == 'justme') $_POST['owner'] = $security_check->username;
		
		$theID = $sql->iudSQL("INSERT into cal_event (
									event_title, 
									event_desc, 
									event_owner) 
								VALUES (
									'" . $_POST['title'] . "', 
									'" . $_POST['desc'] . "', 
									'" . $_POST['owner'] . "')");

		if ($_POST['annualrec'] == 'annual') {
			if (! $_POST['nostart'])
				$_POST['nostart'] = 0;
			$sql->iudSQL("INSERT into cal_annual (
								event_id, 
								annual_startday, 
								annual_endday, 
								annual_interval, 
								annual_nostart) 
							VALUES (
								" . $theID . ", 
								to_days('" . $_POST['start'] . "'), 
								to_days('" . $_POST['end'] . "'), 
								" . $_POST['interval'] . ", 
								" . $_POST['nostart'] . ")");
		}
			
		if ($_POST['specday'] == 'yes')
			$sql->iudSQL("INSERT into cal_specdate (
								specdate_date, 
								event_id) 
							VALUES (
								'" . $_POST['specdate'] . "', 
								" . $theID . ")");
			
		if ($_POST['monthday'] == 'yes')
			$sql->iudSQL("INSERT into cal_dayofmonth (
								dayofmonth_day, 
								event_id) 
							VALUES (
								'" . $_POST['dayofmonth'] . "', 
								" . $theID . ")");
					
	}
}

function showAddForm() {
	global $html;
	$retval = $html->form_start('name="theForm" method="post" action="?insert=yes" onsubmit="return valiDate()"');
	$retval .= $html->h(3,'Schedule New Event:') . $html->br();
	$retval .= $html->table_start();
	$retval .= $html->tr(
						$html->td('Event Title:') . 
						$html->td(
							$html->textinput('title', 'size="30"')
						)
				);
	$retval .= $html->tr(
						$html->td('Event Description:') . 
						$html->td(
							$html->textarea('desc', '', '',10,50)
						)
				);
	$retval .= $html->tr(
						$html->td('Show this event to:') . 
						$html->td(
							$html->radio('owner', 'justme','checked') . 'Just Me' . 
							$html->radio('owner', 'all') . 'Everyone'
						)
				);
	$retval .= $html->tr( 
						$html->td('Recurrance:', 'colspan="2"')
						);
	$retval .= $html->tr(
						$html->td(
							$html->checkbox('annualrec','annual') . 'Every:'
						) .
						$html->td (
							$html->textinput('interval','size="2"') . ' days'
						)
				);
	$retval .= $html->tr(
						$html->td(' ') .
						$html->td(
							'Starting on (yyyy-mm-dd):' . $html->textinput('start', 'id="date"') . 
							$html->br() .
							'Ending on (yyyy-mm-dd):' . $html->textinput('end', 'id="date"') .
							'* Leave both blank for ongoing events.'
						)
				);
	$retval .= $html->tr(
						$html->td(' ') .
						$html->td(
							$html->checkbox('nostart', '1') . 
							'record before start date as well'
						)
				);
	$retval .= $html->tr(
						$html->td(
							$html->checkbox('annualrec','annual') . 'Every:'
						) .
						$html->td (
							$html->textinput('interval','size="2"') . ' days'
						)
				);
	$retval .= $html->tr( 
						$html->td(
							$html->checkbox('specday', 'yes') . 
							'Specific Day:') .
						$html->td(
							'(mm-dd format)' .
							$html->textinput('specdate','size="5"') . 
							' no preceeding zeroes'
						)
				);
	$retval .= $html->tr( 
						$html->td(
							$html->checkbox('monthday', 'yes') . 
							'Day of the month:') .
						$html->td(
							$html->textinput('dayofmonth','size="2"') . 
							' (i.e. every x day of every month)'
						)
				);
	$retval .= $html->table_end();
	$retval .= $html->submit('Add Event');
	
	return $retval;
}
?>
