CREATE TABLE addressbook (
	addressbook_id int not null auto_increment,
	addressbook_email varchar(200) default NULL,
	addressbook_email2 varchar(200) default NULL,
	addressbook_name varchar(200) default NULL,
	addressbook_owner varchar(100) default NULL,
	addressbook_firstname varchar(50) default NULL,
	addressbook_lastname varchar(50) default NULL,
	addressbook_address varchar(200) default NULL,
	addressbook_homephone varchar(20) default NULL,
	addressbook_mobilephone varchar(20) default NULL,
	addressbook_officephone varchar(20) default NULL,
	addressbook_im varchar(20) default NULL,
	addressbook_shared tinyint(4) default 0,
	PRIMARY KEY (addressbook_id)
)

CREATE TABLE cal_event (
	event_id int not null auto_increment,
	event_title varchar(255) default NULL,
	event_desc text default NULL,
	event_owner varchar(100) default NULL,
	PRIMARY KEY (event_id)
)

CREATE TABLE cal_annual (
	annual_id int not null auto_increment,
	annual_interval int(11) default NULL,
	annual_startday int(11) default NULL,
	annual_endday int(11) default NULL,
	annual_nostart int(11) default 0,
	event_id int(11) NOT NULL,
	PRIMARY KEY (annual_id)
)

CREATE TABLE cal_dayofmonth (
	dayofmonth_id int not null auto_increment,
	dayofmonth_day int(11) default NULL,
	event_id int(11) NOT NULL,
	PRIMARY KEY (dayofmonth_id)
)

CREATE TABLE cal_specdate (
	specdate_id int not null auto_increment,
	specdate_date varchar(5) default NULL,
	event_id int(11) NOT NULL,
	PRIMARY KEY (specdate_id)
)

CREATE TABLE profile (
	profile_id int not null auto_increment,
	profile_username varchar(255) NOT NULL,
	profile_displayname varchar(255) default NULL,
	profile_footer text default NULL,
	profile_html tinyint(4) default 0,
	PRIMARY KEY (profile_id)
)