<?php
/**
 * @package MadIrish-Webmail
 * @author Justin C. Klein Keane
 * @version 2.0
 */

require_once ($GLOBALS['basedir']."inc/config.php");
require_once ($GLOBALS['basedir']."lib/html.php");

/**
 * Common sets up initial connections to the server, validates users
 * and handles some global functions.
 *
 */
Class Common extends Html {
	var $username;
	var $password;
	var $server;
	
	function Common() {
		$this->server = $GLOBALS['server'];
		$this->checkSecurity();
		if (! isset($this->username)) $this->username = $_SESSION['username'];
		if (! isset($this->password)) $this->password = $_SESSION['password'];
	}
	
	function checkSecurity() {
		session_name('MadirishWebmail');
		if (! isset($_SESSION['username'])) session_start();
		if (!session_is_registered("username")) {
			session_register('password');
			session_register('username');
			session_register('emailcount');
		}
		if ($_POST['password']) {
			$_SESSION['username'] = $_POST['username'];
			$_SESSION['password'] = $_POST['password'];
		}
		if (!$_SESSION['username']) $this->error();

	}
	
	function error($msg='') {
		if ($msg == 'Bad Login') reportBadLogin();
		header("Location:index.php?msg=$msg");
	}
	
	function fatal_error($msg='') {
		die("$msg");
	}
	
	function reportBadLogin() {
		if ($GLOBALS['report_bad_login'] == 'yes') {
			//send an email to admin or log the bad login in the db
			//not yet implemented
		}
	}
	function returnToInbox() {
		header("Location:inbox.php");
	}
	

	function print_debug($input) {
		print "<pre>";
		print_r($input);
		print "</pre>";
	}
	
	function logOut() {
		session_destroy();
	}
}

?>
