<?php
/**
 * @package MadIrish-Webmail
 * @author Justin C. Klein Keane
 * @version 2.0
 */
require_once ($GLOBALS['basedir']."lib/inbox.php");
Class Email extends Inbox {

	var $msgno;
	var $headers;
	var $boundry;
	
	var $mailbox;
	
	function Email() {
		$this->Inbox();
		$this->mailbox = $this->inbox;
	}
	
	function contentType($style='') {
		if ($style == '') $contentType ="Content-Type: text/plain;\r\n\tcharset=\"us-ascii\"";
		else $conentType = "Content-Type: text/html;\r\n\tcharset=\"us-ascii\"\r\n\r\n";
		$this->headers .= $contentType;
	}
	
	function displayNextPrevious() {
		$max_msgs = $this->imap_obj->Nmsgs;
		if ($this->max_msg_id=='') $this->max_msg_id = $max_msgs;
		$nextX = $this->max_msg_id + $this->delimiter;
		if ($nextX > $this->max_msgs) $nextX = $max_msgs;
		$prevX = $this->max_msg_id - $this->delimiter - 1;
		if ($prevX < 0) $prevX = 0;
		print $this->table_start('id="nextPrevTable"');
		print $this->tr( $this->td( $this->a('inbox.php?max_msg_id='.$nextX.'&delimiter='.$this->delimiter,'Next '.$this->delimiter) ) . $this->td( $this->a('inbox.php?max_msg_id='.$prevX.'&delimiter='.$this->delimiter,'Previous '.$this->delimiter), 'id="right"' ) );
		print $this->table_end();
	}
	
	function getHeader() {
		$this->checkBoxMsg('getHeader()');
		//return an array of titles and content:
		$headers = imap_header($this->mailbox, $this->msgno);
		$retval = array(
			"From:" 		=> 	$headers->fromaddress,
			"Recieved:" 	=> 	$headers->date,
			"Reply To:" 	=> 	$headers->fromaddress,
			"To:" 		=> 	$headers->toaddress,
			"Cc:" 		=>	$headers->ccaddress,
			"Subject:"	=>	$headers->subject
		);
		return $retval;
	}
	function getFullHeaders() {
		$fullheader = imap_fetchheader($this->mailbox, $this->msgno);
		$fullheader = htmlspecialchars($fullheader);
		$fullheader = str_replace("\n", "<br/>", $fullheader);
		return $fullheader;
	}
	
	
	function getReplyHeader() {
		//get headers formatted for message reply
		$this->checkBoxMsg('getHeader()');
		$headers = imap_header($this->mailbox, $this->msgno);
		foreach ($headers->from as $from) {
			$retval['To:'] .= $from->mailbox . '@' . $from->host;
		}
		foreach ($headers->to as $to) {
			//mask return address if it's to ourselves
			if ($to != $this->username && $to->host != $GLOBALS['domain']) {
				if ($retval['To:'] != '') $retval['To:'] .= ', ';
				$retval['To:'] .= $to->mailbox . '@' . $to->host;
			}
		}
		//check to see if there were other recipients in the 'to' field other than user
		
		if (isset($headers->cc)) {
			foreach ($headers->cc as $cc) {
				if ($cc != $this->username && $cc->host != $GLOBALS['domain']) {
					if ($retval['Cc:'] != '') $retval['Cc:'] .= ', ';
					$retval['Cc:'] .= $cc->mailbox . '@' . $cc->host;
				}
			}
		}
		$retval['Subject:'] = $headers->subject;
		return $retval;
	}
	
	function attachmentNumber($msg_no) {
		$part_count = 0;
		
		$message = imap_fetchstructure($this->mailbox, $msg_no);
		$parts = count($message->parts);
		
		if ($parts)
			foreach ($message->parts as $part) 
				if ( $part->parameters[0]->attribute == 'NAME' || $part->parameters[0]->attribute == 'FILENAME' ) 
					$part_count++;
		
		return $part_count;
	}	
	
	function displayAttachment($message_id, $attachment_name, $part, $type, $encoding) {
			$part = $part+2;
			$attachment = imap_fetchbody($this->mailbox, $message_id, $part);
			
			$type = $this->getAppType($attachment_name);
			
				// send headers to browser to initiate file download
				header("Pragma: public");
				header("Expires: 0");
				header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
				header("Cache-Control: public");
				header("Content-Description: File Transfer");
				header ("Content-Type: " . $type);
				header ("Content-Disposition: attachment; filename=" . stripslashes($attachment_name) . "\n;");
				
				
				if ($encoding == "BASE64") {
					// decode and send
					echo imap_base64($attachment);
				}
				else{
					// add handlers for other encodings here
					echo $attachment;
				}
	}
	
	function getAttachment($message_id, $part='') {
			$message_structure = imap_fetchstructure($this->mailbox, $message_id);
			$message_parts = $message_structure->parts;
			$part_count = 0;
			
			foreach ($message_parts as $piece) {
				$part_count++;
				if ($piece->dparameters[0]->attribute == 'FILENAME' && $piece->parameters[0]->attribute == 'NAME') {
					$name = $piece->parameters[0]->value;
					$retpiece[$name]['filename'] = $piece->dparameters[0]->value;
					$retpiece[$name]['enctype'] = $this->getEncType($piece->encoding);
					$retpiece[$name]['apptype'] = $this->getAppType($piece->dparameters[0]->value );
					//$retpiece[$name]['file'] = ($this->getEncType($piece->encoding) == "BASE64") ? imap_base64(imap_fetchbody($this->mailbox, $message_id, $part_count)) : imap_fetchbody($this->mailbox, $message_id, $part_count);
					$retpiece[$name]['file'] = imap_fetchbody($this->mailbox, $message_id, $part_count);
				}
			}
			
			return $retpiece;
	}
	
	function displayAttachmentNames() {
			$this->checkBoxMsg('displayAttachmentNames()');
			$structure = imap_fetchstructure($this->mailbox, $this->msgno);
			if(isset($structure->parts)) {
				$x=0;
				foreach($structure->parts as $part) {
					//figure out if this is an attachment or not (based on the attributes NAME or FILENAME)
					if ( $part->parameters[0]->attribute == 'NAME' || $part->dparameters[0]->attribute == 'FILENAME' ) {
						$retval[$x]['name']  = $part->parameters[0]->value;
						$retval[$x]['linkname']  = urlencode($part->parameters[0]->value);
						$retval[$x]['encoding'] = $this->getEncType($part->encoding);
						$retval[$x]['type'] = $this->getStrictAppType($part->type);
						$retval[$x]['part'] = $x;
						$x++;
					}
				}
			}
		return $retval;
	}	
	
	function displayBody($displayHtml=0) {
			$this->checkBoxMsg('displayBody()');
			$structure = imap_fetchstructure($this->mailbox, $this->msgno);
			if ($structure->type == 1)  {
   				$body = imap_fetchbody($this->mailbox,$this->msgno,"1");
   				
   				//might have to base64 decode the message
   				if (imap_base64($body))
   					$body = imap_base64($body);
   					
				if ($displayHtml != 1) {
					$body = htmlspecialchars($body);
					//strange formatting fix for mbox
					$body = str_replace("=\r\n", '', $body);
					//insert line breaks
					$body = str_replace("\n", '<br/>', $body);
				}
   				if(!$body) {$body = '[NO TEXT ENTERED INTO THE MESSAGE]\n\n';}
  			}
  			else {
   				$body = imap_body($this->mailbox, $this->msgno);
				$body = htmlspecialchars($body);
				if ($displayHtml != 1) {
					//$body = htmlspecialchars($body);
					$body = str_replace("\n", '<br/>', $body);
				}
   				if(!$body) {$body = '[NO TEXT ENTERED INTO THE MESSAGE]\n\n';}
  			}
  			return $body;
	}
	
	function checkBoxMsg($function) {
		if (! isset($this->mailbox) || ! isset($this->msgno) ) $this->fatal_error('Missing mailbox or message number in '.$function);
	}	
	
	function getEncType($type) {
		switch($type) {
				case 0:
					return "7BIT";
					break;
				case 1:
					return "8BIT";
					break; 
				case 2:
					return "BINARY";
					break; 
				case 3:
					return "BASE64";
					break; 
				case 4:
					return "QUOTED-PRINTABLE";
					break; 
				case 5:
					return "OTHER";
					break; 
		}

	}
	
	function getAppType($filename) {
		switch( strtolower(substr($filename,-3)) ) {
			     case "pdf": $type="application/pdf"; return $type; break;
			     case "exe": $type="application/octet-stream"; return $type; break;
			     case "zip": $type="application/zip"; return $type; break;
			     case "doc": $type="application/msword"; return $type; break;
			     case "xls": $type="application/vnd.ms-excel"; return $type; break;
			     case "ppt": $type="application/vnd.ms-powerpoint"; return $type; break;
			     case "gif": $type="image/gif"; return $type; break;
			     case "png": $type="image/png"; return $type; break;
			     case "tif": $type="image/tif"; return $type; break;
			     case "jpeg":
			     case "jpg": $type="image/jpg";  return $type; break;
			     case "mp3": $type="audio/mpeg";  return $type; break;
			     case "wav": $type="audio/x-wav"; return $type; break;
			     case "mpeg":
			     case "mpg":
			     case "mpe": $type="video/mpeg"; return $type; break;
			     case "mov": $type="video/quicktime"; return $type; break;
			     case "avi": $type="video/x-msvideo"; return $type; break;
			     default: return "text/plain"; break;
				 }
	}
	
	function getStrictAppType($num) {
		
				switch ($num) {
					case 0:
						$retval ="text";
						break;
					case 1:
						$retval ="multipart";
						break;
					case 2:
						$retval ="message";
						break;
					case 3:
						$retval ="application";
						break;
					case 4:
						$retval ="audio";
						break;
					case 5:
						$retval ="image";
						break;
					case 6:
						$retval ="video";
						break;
					case 7:
						$retval ="other";
						break;
				}
				
				return $retval;
	}
	

}

?>
