<?php
/**
 * @package MadIrish-Webmail
 * @author Justin C. Klein Keane
 * @version 2.0
 */
require_once ($GLOBALS['basedir']."lib/email.php");

Class Email_SMTP extends Email {
	
	var $fromname;
	var $from;
	var $cc;
	var $bcc;
	var $recipient;
	var $subject;
	var $mBody;
	var $attachments;
	var $style;
	
	function Email_SMTP() {
		$this->Email();
		if (! isset($this->fromname))
			$this->fromname = $this->username . '@' . $GLOBALS['domain'];
		if (! isset($this->from))
			$this->from = $this->fromname;
			
		// create a MIME boundary string
		$this->boundary = "=====" . $GLOBALS['domain'] . "." . md5(uniqid(time())) . "=====";
	}
	
	function buildStandardHeaders($post_files) {
		$this->headers = "FROM:\"" . $this->fromname . "\" <" . $this->from . ">\r\n";
		
		if($this->cc) 
			$this->headers .= "Cc: " . $this->cc . "\r\n"; 
		if($this->bcc)
			$this->headers .= "Bcc: " . $this->bcc . "\r\n"; 
		
		$forward = ($this->option == 'forward' && isset($this->msgno)) ? 1 : 0;
				
		if ($post_files || ($forward)) 
			$this->addAttachmentHeaders();
			
		
		if ($post_files) {
			
			foreach ($post_files as $attachment) 
				$this->attachments .= $this->addAttachment($attachment);

		}
		
		//check to see if there are any forwarded attachments from the original message
		if ($forward) {
			$attachments_to_forward = $this->getAttachment($this->msgno);
			
				foreach($attachments_to_forward as $forward) {
							
							$this->attachments .= "\r\n--" . $this->boundary . "\r\n";
							$this->attachments .= "Content-Type: " . $forward['apptype'] . ";\r\n\tname=\"" .
										$forward['name'] . "\"\r\n";
							$this->attachments .= "Content-Transfer-Encoding: " . $forward['enctype'] . "\r\n";
							$this->attachments .= "Content-Disposition: attachment; \r\n\tfilename=\"" . 
									$forward['filename'] . "\"\r\n\r\n";
									
							$this->attachments .= $forward['file'];
							
					}
		}
		
		//add final boundary
		if ($post_files || ($forward)) 
			$this->attachments .= "\r\n--" . $this->boundary . "--\r\n\r\n";
		
	}
	
	function addAttachmentHeaders() { 
			// add MIME data to the message headers
			$this->headers .= "MIME-Version:1.0\r\n";
			$this->headers .= "Content-Type: multipart/mixed;\r\n\tboundary=\"" . $this->boundary . "\"\r\n\r\n";
			
			// start building a MIME message
			// first part is always the message body
			// encode as 8-bit text

			$str = "This message is in MIME format.\r\n" .
					"\r\n--" . $this->boundary . "\r\n";
			
			if ($this->style == "1") 
				$str .= "Content-Type: text/html;  charset=\"us-ascii\"\r\n";
			else 
				$str .= "Content-Type: text/plain; charset=ISO-8859-1\r\n";
			
			$str .= "Content-Transfer-Encoding: 8bit\r\n\r\n";
			
			$this->headers .= $str;
	}
	
	function addAttachment($array) {
		extract($array);
		// encode each and attach it as a MIME-encoded section
		for ($i=0;$i<count($name);$i++) {
				$fp = fopen($tmp_name[$i], "rb");
				$data = fread($fp, filesize($tmp_name[$i]));
				$data = chunk_split(base64_encode($data));
				fclose($fp);
			
				// add the MIME data
				$str .= "\r\n--" . $this->boundary . "\r\n";
				$str .= "Content-Type: " . $type[$i] . ";\r\n\tname=\"" .
						$name[$i] . "\"\r\n";
				$str .= "Content-Transfer-Encoding: base64\r\n";
				$str .= "Content-Disposition: attachment; \r\n\tfilename=\"" . 
						$name[$i] . "\"\r\n\r\n";
				$str .= $data;
		}
		// all done
		return $str;
	}
	
	function send() {
		$this->mBody = stripslashes($this->mBody);
		$this->mBody .= "\r\n" . $this->attachments;
		$this->subject = stripslashes($this->subject);
		mail($this->recipient, $this->subject, $this->mBody, $this->headers ) or die ("Failed to send the message using Email_SMTP::send().");
	}
	
}
?>