<?php
/**
 * @package MadIrish-Webmail
 * @author Justin C. Klein Keane
 * @version 2.0
 */
Class Html {
	function a($href, $text, $params='') {
		return "<a href='$href' $params>$text</a>"; 
	}
	function br($params='') {
		$retval =  "<br"; 
		if ($params != '') 
			$retval .= ' ' . $params;
		$retval .= "/>\n";
		return $retval; 
	}
	function button($params='') {
		$retval = '<input type=\'button\'';
		if (isset($params)) $retval .= " $params";
		$retval .= '/>';
		return $retval;
	}
	function checkbox($name, $value='', $params='') {
		$retval = '<input type="checkbox" name="'.$name.'" value="' . $value . '" '. $params . '/>';
		return $retval;
	}
	function div($id='',$name='',$params='', $text='') {
		return '<div id="' . $id . '" name="' . $name . '" ' . $params . '>' . $text . '</div>';
	}
	function div_end() {
		return "</div>\n";
	}
	function div_start($id, $params='') {
		return "<div id='$id' " . $params . ">\n";
	}
	function form_end() {
		return "</form>\n";
	}
	function form_start($params='') {
		return "<form $params>\n";
	}
	function h($number, $text='', $params='') {
		$retval = '<h' . $number;
		if ($params != '')
			$retval .= ' ' . $params;
		$retval .= ">$text</h" . $number . ">\n";
		return $retval;
	}
	function hidden($name, $value='', $params='') {
		$retval = '<input type="hidden" name="'.$name.'" value="' . $value . '" '. $params . '/>';
		return $retval;
	}
	function hr($params='') {
		$retval =  "<hr"; 
		if ($params != '') 
			$retval .= ' ' . $params;
		$retval .= "/>\n";
		return $retval; 
	}
	function javascript($source_file) {
		$retval = '<script type=\'text/javascript\' src=\'js/' . $source_file . '\'></script>'."\n";
		return $retval;
	}
	function li($string, $params='') {
		return "\n\t<li $params>$string</li>";
	}
	function p($string, $params='') {
		$retval= "<p";
		if ($params != '')
			$retval .= ' ' . $params;
		$retval .=">$string</p>\n";
		return $retval;
	}
	function password($name='', $params='') {
		$retval = '<input type=\'password\' name=\'' . $name . '\'';
		if (isset($params)) $retval .= " $params";
		$retval .= '/>';
		return $retval;
	}
	function radio($name='',$value='',$checked='',$params='') {
		$retval = '<input type="radio" name="' . $name . '" value="' . $value . '"';
		if ($checked != '') 
			$retval .= ' checked="checked"';
		if ($params != '')
			$retval .= ' ' . $params;
		$retval .= '/>';
		return $retval;
	}
	function select($optionsArray, $params='', $default='') {
		$retval = '<select';
		if (isset($params)) 
			$retval .= ' ' . $params . ">\n";
		foreach ($optionsArray as $value => $display) { 
			$retval .= "\t<option value='$value'";
			if ($value == $default) {	
				$retval .= " selected";	
			}
			$retval .= ">$display</option>\n";
		}
		$retval .= "</select>\n";
		return $retval;
	}
	function submit($value='',$params='') {
		$retval = '<input type=\'submit\'';
		if ($value != '') $retval .= " value='$value'";
		if ($params != '') $retval .= " $params";
		$retval .= "/>\n";
		return $retval;
	}
	function table_end() {
		return "</table>\n";
	}
	function table_start($params='') {
		$retval = "<table $params>\n";
		return $retval;
	}
	function td($string, $params='') {
		$retval = "\n\t<td $params>$string</td>\n";
		return $retval;
	}
	function textarea($name='',$value='',$params='', $rows='10', $cols='85') {
		$retval = '<textarea';
		if ($name != '') $retval .= ' name=\''.$name.'\'';
		if ($value != '') $retval .= " $params";
		$retval .= " rows='$rows' cols='$cols'>$value</textarea>\n";
		return $retval;
	}
	function textinput($name='', $params='') {
		$retval = '<input type=\'text\' name=\'' . $name . '\'';
		if (isset($params)) $retval .= " $params";
		$retval .= '/>';
		return $retval;
	}
	function tr($string, $params='') {
		$retval = "<tr $params>$string</tr>\n";
		return $retval;
	}
	function ul($string, $params='') {
		return "<ul $params>$string\n</ul>\n";
	}
}

?>
