<?php
/**
 * @package MadIrish-Webmail
 * @author Justin C. Klein Keane
 * @version 2.0
 */

require_once ($GLOBALS['basedir']."lib/common.php");

Class Inbox extends Common {
	
	var $inbox;
	var $imap_obj;
	
	var $min_msg_id;
	var $max_msg_id;
	var $delimiter;
	
	function Inbox() {
		$this->Common();
		$this->inbox = @imap_open("{".$GLOBALS['server'].":110/pop3}INBOX", 
									$this->username, 
									$this->password) 
						or $this->error('Bad credentials, could not open inbox. -' . $this->username);
		
		$this->imap_obj =  imap_check($this->inbox);
		
		if (! isset($this->delimiter)) 
			$this->delimiter = 25;
	}
	
	
	function getMailOverview() {
		if ($this->max_msg_id=='') 
			$this->max_msg_id = $this->imap_obj->Nmsgs;
			
		$min_msg_id = $this->max_msg_id - $this->delimiter;
		
		$overview = imap_fetch_overview($this->inbox, "$this->max_msg_id:$min_msg_id", 0);
		
		return $overview;
	}	
	
	function get_Inbox() {
		$overview = $this->getMailOverview();
		$overview = array_reverse($overview);
		
		foreach ($overview as $mail) {

			if ($mail->subject == '') $mail->subject = '[no subject]';

			$message->msgno			= $mail->msgno;
			$message->subject 		= htmlspecialchars($mail->subject);
			$message->from 			= htmlspecialchars($mail->from);
			$message->date 			= $mail->date;
			$message->attachments 	= $this->attachmentNumber($mail->msgno);
			
			$retval[] = $message;

		}
		
		return $retval;		
	}
	
	function attachmentNumber($msg_no) {
		$part_count = 0;
		
		$message = imap_fetchstructure($this->inbox, $msg_no);
		$parts = count($message->parts);
		
		if ($parts)
			foreach ($message->parts as $part) 
				if ( $part->parameters[0]->attribute == 'NAME' || $part->parameters[0]->attribute == 'FILENAME' ) 
					$part_count++;
		
		return $part_count;
	}	
	
	function getNextPrevious() {
		$max_msgs = $this->imap_obj->Nmsgs;
		if ($this->max_msg_id=='') $this->max_msg_id = $max_msgs;
		$nextX = $this->max_msg_id + $this->delimiter;
		if ($nextX > $this->max_msgs) $nextX = $max_msgs;
		$prevX = $this->max_msg_id - $this->delimiter - 1;
		if ($prevX < 0) $prevX = 0;
		
		$retval->nextX = $nextX;
		$retval->prevX = $prevX;
		
		return $retval;
	}
	
	function deleteEmail($ids) {
		foreach ($ids as $id)
			imap_delete($this->inbox, $id);
		imap_expunge($this->inbox);
		
		header("Location:inbox.php");
	}

}
?>